"use strict";

$(function() {
    var selected, criticalEdition, ocrInput, rbSimulated, ocrResult, currentLinks, currentPage, 
            currentCriticalEditionLine, algorithmType,
            
            criticalEditionText, _criticalEditionText,
            allGoodLinks, allGoodText,
            missingGoodLinks, missingGoodText,
            allBadLinks, allBadText,
            missingBadLinks, missingBadText,
            rbSimulated;

    selected = 0;
    algorithmType = 0;
    currentPage = null;
    criticalEditionText = [
        "11001 vfdDiH At Ec",
        "11002 at eN guRaH",
        "11003 ikaH guRavfdDI",
        "11004 na DAtulope ArDaDAtuke",
        "11005 kNiti ca",
        "11006 dIDIvevIwAm",
        "11007 halaH anantarAH saMyogaH",
        "11008 muKanAsikAvacanaH anunAsikaH",
        "11009 tulyAsyaprayatnam savarRam",
        "11010 na ajJalO",
        "11011 IdUdet dvivacanam pragfhyam",
        "11012 adasaH mAt",
        "11013 Se",
        "11014 nipAtaH ekAc anAN",
        "11015 ot",
        "11016 sambudDO SAkalyasya itO anArze"
    ];
    
    _criticalEditionText = [];

    allGoodLinks = [
        0, 0, 0, 0,
        1, 1, 1, 1,
        2, 2, 2, 2,
        3, 3, 3, 3
    ];

    allGoodText = [
        [
            "11001 vfdDiH At Ec 11002 at eN guRaH",
            "11003 ikaH guRavfdDI 11004 na DAtulope ArDaDAtuke"
        ],
        [
            "11005 kNiti ca 11006 dIDIvevIwAm",
            "11007 halaH anantarAH saMyogaH 11008 muKanAsikAvacanaH anunAsikaH"
        ],
        [
            "11009 tulyAsyaprayatnam savarRam 11010 na ajJalO",
            "11011 IdUdet dvivacanam pragfhyam 11012 adasaH mAt"
        ],
        [
            "11013 Se 11014 nipAtaH ekAc anAN",
            "11015 ot 11016 sambudDO SAkalyasya itO anArze"
        ]
    ];
    
    missingGoodLinks = [
        0, 0, 0, 0,
        -1, -1, -1, -1,
        -1, -1, -1, -1,
        1, 1, 1, 1
    ];

    missingGoodText = [
        [
            "11001 vfdDiH At Ec 11002 at eN guRaH",
            "11003 ikaH guRavfdDI 11004 na DAtulope ArDaDAtuke"
        ],
        [
            "11013 Se 11014 nipAtaH ekAc anAN",
            "11015 ot 11016 sambudDO SAkalyasya itO anArze"
        ]
    ];
    
    allBadLinks = [
        0, 0, 0, 0,
        1, 1, 1, 1,
        2, 2, 2, 2,
        3, 3, 3, 3
    ];

    allBadText = [
        [
            "11001 vfdDiH Ax Ex 11002 at eN guRaH",
            "11003 ikaH guxavfdDx 11004 na DAtulope ArDaDAtuke"
        ],
        [
            "11005 kNiti ca 11006 dIDIvevIwAm",
            "11007 halaH anantarAH saMyogaH 11008 muKanAsikAxacanxH anunAsikaH"
        ],
        [
            "11009 tulyAsyapraxatnam savarxam 11010 na ajJalO",
            "11011 IdUdet dxixacanam pragxhyam 11012 adasaH mAt"
        ],
        [
            "11013 Se 11014 nipxtaH ekAc anAN",
            "11015 ot 11016 sambxdDO SAkxlyasya itO anArze"
        ]
    ];
    
    missingBadLinks = [
        0, 0, 0, 0,
        -1, -1, -1, -1,
        -1, -1, -1, -1,
        1, 1, 1, 1
    ];

    missingBadText = [
        [
            "11001 vfdDiH Ax Ex 11002 at eN guRaH",
            "11003 ikaH guxavfdDx 11004 na DAtulope ArDaDAtuke"
        ],
        [
            "11013 Se 11014 nipxtaH ekAc anAN",
            "11015 ot 11016 sambxdDO SAkxlyasya itO anArze"
        ]
    ];
    
    ocrResult = [
        {text: allGoodText, links: allGoodLinks, compressed:[]},
        {text: missingGoodText, links: missingGoodLinks, compressed:[]},
        {text: allBadText, links: allBadLinks, compressed:[]},
        {text: missingBadText, links: missingBadLinks, compressed:[]}
    ];

    criticalEdition = $("#criticalEdition");
    ocrInput = $("#ocrInput");

    initializeCriticalEdition(criticalEditionText);
    initializeOCRResult(ocrResult[selected]);
    
    $('input[name=algorithm]:radio').change(function(evt) {
        var id;
        
        id = evt.currentTarget.id;
        if (id === "rbSimulated") {
            algorithmType = 0;
        } else if (id === "rbEditDistance") {
            algorithmType = 1;
        }        
        
        if (currentCriticalEditionLine) {
            selectPage({currentTarget:currentCriticalEditionLine});  // fake a click on critical edition line to cause page selection algorithm to fire
        }
    });

    $('input[name=searchtype]:radio').change(function(evt) {
        var id;

        id = evt.currentTarget.id;
        if (id === "rbAllGood") {
            selected = 0;
        } else if (id === "rbMissingGood") {
            selected = 1;
        } else if (id === "rbAllBad") {
            selected = 2;
        } else if (id === "rbMissingBad") {
            selected = 3;
        }

/*        
        if (currentCriticalEditionLine) {
            currentCriticalEditionLine.css("color", "black");
            currentCriticalEditionLine = null;
        }
*/

        initializeOCRResult(ocrResult[selected]);        
    });


    function levenshteinDistance(s, t) {
        if (s.length === 0)
            return t.length;
        if (t.length === 0)
            return s.length;

        return Math.min(
                levenshteinDistance(s.substr(1), t) + 1,
                levenshteinDistance(t.substr(1), s) + 1,
                levenshteinDistance(s.substr(1), t.substr(1)) + (s[0] !== t[0] ? 1 : 0)
                );
    }


    // Compute the edit distance between the two given strings
    function getEditDistance(a, b) {
        if (a.length === 0)
            return b.length;
        if (b.length === 0)
            return a.length;

        var matrix = [];

        // increment along the first column of each row
        var i;
        for (i = 0; i <= b.length; i++) {
            matrix[i] = [i];
        }

        // increment each column in the first row
        var j;
        for (j = 0; j <= a.length; j++) {
            matrix[0][j] = j;
        }

        // Fill in the rest of the matrix
        for (i = 1; i <= b.length; i++) {
            for (j = 1; j <= a.length; j++) {
                if (b.charAt(i - 1) === a.charAt(j - 1)) {
                    matrix[i][j] = matrix[i - 1][j - 1];
                } else {
                    matrix[i][j] = Math.min(matrix[i - 1][j - 1] + 1, // substitution
                            Math.min(matrix[i][j - 1] + 1, // insertion
                            matrix[i - 1][j] + 1)); // deletion
                }
            }
        }

        return matrix[b.length][a.length];
    }

    // called when user click line of critical edition text
    function selectPage(evt) {
        var n, page;
        
        if (currentCriticalEditionLine) {
            currentCriticalEditionLine.css("color", "black");
        }
        
        currentCriticalEditionLine = $(evt.currentTarget);
        currentCriticalEditionLine.css("color", "red");
        
        n = parseInt(currentCriticalEditionLine.attr("id").substring(1));

        if (algorithmType === 0) {      // simulated            
            _selectPage(currentLinks[n]);
        } else if (algorithmType === 1) {    // edit distance
            page = algorithmEditDistance(_criticalEditionText[n]);
            _selectPage(page);
        }
    }


    function algorithmEditDistance(line) {
        var ocr, numPages, i, page, minimums, numChars, j, chunk, celen, min, ed;
        
        ocr = ocrResult[selected];
        if (ocr.compressed.length === 0) {
            compressOCR(ocr);
        }
        
        celen = line.length;
        numPages = ocr.compressed.length;
        minimums = [];
        for (i=0; i < numPages; i++) {
            page = ocr.compressed[i];
            numChars = page.length;
            min = 65536;
            for (j=0; j < numChars; j++) {
                chunk = page.substr(j, celen);
                if (chunk.length < celen) {
                    break;
                }
                ed = getEditDistance(line, chunk);
                if (ed < min) {
                    min = ed;
                }
            }
            minimums.push(min);
        }
        
        min = 65536;
        j = 0;      // will be index of page with smallest computed edit distance.
        for (i=0; i < numPages; i++) {
            if (minimums[i] < min) {
                min = minimums[i];
                j = i;
            }
        }
        
        if (min > celen/3) {
            return -1;
        } else {
            return j;
        }
    }
    
    
    function compressOCR(ocr) {
        var numPages, i, numLines, j, buffer, text, page;
        
        text = ocr.text;
        numPages = text.length;
        for (i=0; i < numPages; i++) {
            page = text[i];
            buffer = "";
            numLines = page.length;
            for (j=0; j < numLines; j++) {
                buffer += compress(page[j]);
            }
            ocr.compressed.push(buffer);
        }
    }
    
    
    function _selectPage(pageNumber) {
        var n;

        if (currentCriticalEditionLine) {
            if (currentPage) {
                currentPage.css("background-color", "white");
            }

            if (pageNumber !== -1) {
                currentPage = $("#p" + pageNumber);
                currentPage.css("background-color", "red");
            } else {
                alert("No page found");
            }
        }
    }

    function initializeCriticalEdition(text) {
        var i, len, span, br, h3;

        len = text.length;
        for (i = 0; i < len; i++) {
            if (i === 0) {
                h3 = $("<h3>");
                criticalEdition.append(h3);
                h3.text("Critical Edition");
            }
            span = $("<span>");
            criticalEdition.append(span);
            span.attr("id", "c" + i);
            span.click(selectPage);
            span.html(text[i]);
            br = $("<br>");
            criticalEdition.append(br);
        }
        if (_criticalEditionText.length === 0) {
            for (i=0; i < len; i++) {
                _criticalEditionText.push(compress(text[i]));
            }
        }
    }

    function compress(a) {
        var i, numLines, numChars, j, buffer, line, ch;

        function _compress(s) {
            s = s.replace(/[0-9]/g, "");
            s = s.replace(/\s/g, "");
            
            return s;
        }
        
        
        buffer = "";
        if (typeof a === "string") {
            buffer = _compress(a);
        } else {
            numLines = a.length;
            for (i = 0; i < numLines; i++) {
                line = a[i];
                if (typeof line === "string") {
                    buffer += _compress(line);
                } else {        // assume it is an array
                    buffer += compress(line);
                }
            }
        }

        return buffer;
    }
    

    function initializeOCRResult(ocr) {
        var i, numPages, j, numLines, obj, div, span, br, pages, page, h3;

        ocrInput.empty();
        pages = ocr.text;
        currentLinks = ocr.links;
        numPages = pages.length;
        for (i = 0; i < numPages; i++) {
            if (i === 0) {
                h3 = $("<h3>");
                ocrInput.append(h3);
                h3.text("OCR results");
            }
            page = pages[i];
            div = $("<div>");
            ocrInput.append(div);
            div.attr("id", "p" + i);
            numLines = page.length;
            for (j = 0; j < numLines; j++) {
                span = $("<span>");
                div.append(span);
                span.html(page[j]);
                br = $("<br>");
                div.append(br);
            }
            ocrInput.append($("<br>"));
        }
        if (currentCriticalEditionLine) {
            selectPage({currentTarget:currentCriticalEditionLine});          // choose page associated with currently selected line of critical edition    
        }
    }    
});

